<?php

namespace Drupal\overview_builder\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\overview_builder\OverviewBuilderInterface;

/**
 * Plugin implementation of 'overview_builder_plugin_reference_build'.
 *
 * @FieldFormatter(
 *   id = "overview_builder_plugin_reference_build",
 *   label = @Translation("Plugin Reference overview builder"),
 *   field_types = {
 *     "plugin_reference"
 *   }
 * )
 */
class PluginReferenceOverviewBuilder extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode): array {
    $elements = [];

    foreach ($items as $delta => $item) {
      $plugin = $item->referencedPlugin();
      if ($plugin instanceof OverviewBuilderInterface) {
        $elements[$delta] = $plugin->build();
      }
    }

    return $elements;
  }

}
